﻿
using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Collections;
using System.Drawing.Drawing2D;

namespace ENTROPY
{
	/// <summary>
	/// Description of EntropyViewer.
	/// </summary>
	public partial class EntropyViewer : UserControl
	{
		public EntropyViewer()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}


		bool running=false;
		List <int> distribution=new List <int> ();
		List <double> distributionReal=new List <double> ();
        
        float graphDiv; 
        List<distList> _entRect = new List<distList>();

        struct distList
        {
            double distributionPercentage;
            RectangleF r;
            string Val;
            PointF A;
            PointF B;

            internal distList(double a, RectangleF b, string c, PointF d, PointF e)
            {
                distributionPercentage = a;
                r = b;
                Val = c;
                A = d;
                B = e;
            }

            public double DistList
            {
                get { return distributionPercentage; }
            }

            public RectangleF Rectangle
            {
                get { return r; }
            }

            public String ByteVal
            {
                get { return Val; }
            }

            public PointF LineStart
            {
                get { return A; }
            }
            public PointF LineEnd
            {
                get { return B; }

            }

        }

        void EntropyViewerLoad(object sender, EventArgs e)
        {
            //
        }
		 
        private void init() {

            distribution.Clear();
            distributionReal.Clear();
            running = false;
            _entRect.Clear();
        }


		public void setBuffer(byte [] c){
            init();
            
            byte [] buffer;
		    int [] counter=new int [256] ;
			distribution.Clear();
		    buffer=c;
		
        for (int i=0;i<256;i++){
			 counter[i]=0;
		}
		
		for (int y=0; y<buffer.Length;y++){
			int tmp=(int)buffer[y];
			counter[tmp]++;
		}
		

		for (int k=0; k<256;k++){

            distributionReal.Add(((double)counter[k]*100)/(double)c.Length);	
		}

		running=true;
		Invalidate();
		}
		
	
	   
	    
	    //graphics related code
	
	    public void LineWidth(int a){
	    	lWd=a;Invalidate();
	    }
	    
	    public void fontSize(int a){
	    	fWd=a; Invalidate();
	    }
	    
	    int fWd=9; //default
	    int lWd=2; //default
	    PointF k; PointF ksub;

        PointF mm;
        string displayValue = String.Empty;
        bool OnDisp = false;
        RectangleF tmp;
        PointF LineSta;
        PointF EndSta;


		void EntropyViewerPaint(object sender, PaintEventArgs e)
		{
            try
            {
                if (running == true)
                {
                    _entRect.Clear();
                    graphDiv = ((float)this.Height - 1) / (float)256;

                    int cnt = 0;
                    LinearGradientBrush lb = new LinearGradientBrush(new Point(0, 0), new Point(0, 5), Color.Teal, Color.White);
                    lb.SetBlendTriangularShape(0.4f, 0.5f);
                    for (float h = 0; h < (float)this.Height; h += graphDiv)
                    {
                        e.Graphics.DrawLine(new Pen(lb, lWd), new PointF((float)(this.Width - 1), h), new PointF(((float)this.Width - ((float)(distributionReal[cnt]) * this.Width)/100.0f), h)); //there was div-by 100
                        RectangleF r = new RectangleF(new PointF(0, h), new SizeF((float)(this.Width), h));
                        _entRect.Add(new distList(distributionReal[cnt], r, (cnt.ToString("X2")), new PointF((float)(this.Width - 1), h), new PointF(((float)this.Width - ((float)distributionReal[cnt] * this.Width)/100.0f), h)));

                        if (cnt < 255) { cnt++; } else { break; }
                    }

                    if (OnDisp == true)
                    { //for brushing info

                        if ((tmp.Height) <= (float)(this.Height / 2))
                        {
                            k = new PointF(1, tmp.Height + 30);
                            ksub = new PointF(1, tmp.Height + 43);
                        }
                        else if ((tmp.Height) > ((float)((3 / 4) * this.Height)) && tmp.Height < this.Height - 50)
                        {
                            k = new PointF(1, tmp.Height - 20);
                            ksub = new PointF(1, tmp.Height - 7);
                        }
                        else if ((tmp.Height > (this.Height - 30) && tmp.Height < (this.Height - 1)))
                        {
                            k = new PointF(1, this.Height - 50);
                            ksub = new PointF(1, this.Height - 37);

                        }
                        e.Graphics.DrawString(displayValue.Split(',')[0], new Font("Arial", 8), new SolidBrush(Color.White), k);
                        e.Graphics.DrawString("0x"+displayValue.Split(',')[1], new Font("Arial", 8), new SolidBrush(Color.White), ksub);
                        LinearGradientBrush lb2 = new LinearGradientBrush(new Point(0, 0), new Point(0, 5), Color.Yellow, Color.Yellow);
                        lb.SetBlendTriangularShape(0.4f, 0.5f);
                        e.Graphics.DrawLine(new Pen(lb2, 2), LineSta, EndSta);

                    }

                    e.Graphics.DrawString("0", new Font("Arial", fWd), new SolidBrush(Color.White), new Point(0, 0));
                    SizeF s = e.Graphics.MeasureString("255", new Font("Arial", 9));
                    e.Graphics.DrawString("255", new Font("Arial", fWd), new SolidBrush(Color.White), new Point(0, this.Height - (int)s.Height - 1));


                }
                else
                {
                    e.Graphics.DrawString("0", new Font("Arial", 9), new SolidBrush(Color.White), new Point(0, 0));
                    SizeF s = e.Graphics.MeasureString("255", new Font("Arial", 9));
                    e.Graphics.DrawString("255", new Font("Arial", 9), new SolidBrush(Color.White), new Point(0, this.Height - (int)s.Height - 1));//this.Width-(int)s.Width-1
                }
            }
            catch (Exception tt) {

                MessageBox.Show("There was an error while drawing the graph. {0}", tt.Message.ToString());
                this.Invalidate();
            }
		}
		
		
		void EntropyViewerMouseMove(object sender, MouseEventArgs e)
		{
			
        	 string val=String.Empty;
			
                 mm=new PointF((float)e.X,(float)e.Y); 
					foreach (distList j in _entRect){
						if (j.Rectangle.Contains(mm)==true){ //chk for point in var md hence required
                             tmp=j.Rectangle; LineSta=j.LineStart; EndSta=j.LineEnd;
                            //val = j.DistList.ToString();
                            displayValue=j.DistList.ToString()+" % "+ ","+j.ByteVal;
                            OnDisp=true;
                    
                 }
                     Invalidate();
				}
                 
                 
                 
		}
		
		void EntropyViewerMouseLeave(object sender, EventArgs e)
		{
			OnDisp=false;
			Invalidate();
		}
	}
}
